/* DS1302:  RST pin    -> Arduino Digital 2
//          DAT pin   -> Arduino Digital 3
          CLK pin  -> Arduino Digital 4
          */
/*
  Diagrama de conexión de Arduino al lectorSD
  GND > GND
   5V > Vcc
  D12 > MISO
  D11 > MOSI
  D13 > SCK
   D9 > CS
*/
/*
  Programa para probar la pantalla LCD 16x2 I2C.
  Este programa usa dos potenciómetros conectados a A0 y A1.
  Conexiones de la pantalla al Arduino:
  GND > GND
  VCC > 5v
  SDA > A4
  SCL > A5
  Tutorial: https://www.geekfactory.mx/tutoriales/tutoriales-arduino/lcd-16x2-por-i2c-con-arduino/
  Librería: https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads/
*/
/*RTC
#include <DS1302.h>
//SD
#include <SD.h>
*/
//LCD
#include  <Wire.h>
#include <LiquidCrystal_I2C.h>

//Sensor de temperatura
#include <OneWire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 11 // Sensor on digital Pin 12 of the Arduino
OneWire oneWire(ONE_WIRE_BUS); // Setup a oneWire instance to communicate with ANY OneWire devices
DallasTemperature sensors(&oneWire); // Pass our oneWire reference to Dallas Temperature.

int led = 13;
/*
LiquidCrystal_I2C lcd(0x27, 16,2);
//Si la pantalla no funciona intenta cambiar el parámetro a 0x3F 0x27

int iniciarPrograma = 0;

//Variables para el botón
int led = 13;
//int button = 8;
//int state = LOW;
//int flag = 0;
//int count = 0;

//Variables para el potenciometro
//int pot = A2;
//long valpot;
//int mvalpot = 70;
*/
//Variables para el sensor de humedad
int val = 0; //value for storing moisture value 
int soilPin = A0;//Declare a variable for the soil moisture sensor 
//int soilPower = 7;//Variable for Soil moisture Power
int val_2 = 0; //value for storing moisture value 
int soilPin_2 = A1;//Declare a variable for the soil moisture sensor 
//int soilPower_2 = 7;//Variable for Soil moisture Power
int mval;
int mval_2;

//Variables para el sensor de temperatura
//float T1, T2;

//Variables para la válvula
//int valve = 12;


void setup()
{
  Serial.begin(9600);
  /* Set the clock to run-mode, and disable the write protection
  rtc.halt(false);
  rtc.writeProtect(false);
  // The following lines can be commented out to use the values already stored in the DS1302
  //rtc.setDOW(WEDNESDAY);        // Set Day-of-Week
  //rtc.setTime(17, 33, 10);     // Set the time (24hr format)
  //rtc.setDate(25, 4, 2018);   // Set date DD/MM/YY
  if (!SD.begin(SDpin))
  {
    Serial.println(F("Error al iniciar"));
    lcd.println("Error al iniciar");
    return;
  }
  Serial.println(F("Iniciado correctamente"));
  */
   /* sensors.begin();      // Start up the OneWire library
  lcd.begin(16, 2);
  lcd.home();
  lcd.println("Iniciado correcto");
//Estados iniciales
  //pinMode(soilPower, OUTPUT);//Set D7 as an OUTPUT
  //digitalWrite(soilPower, LOW);//Set to LOW so no power is flowing through the sensor
  pinMode(led, OUTPUT);
  pinMode (button, INPUT);
  pinMode (valve, OUTPUT);
  digitalWrite(valve, LOW); */
}
 
void loop()
{
  /* /state = digitalRead(button);
 but_state();
 if (count == 1){
    readSensor();
    sensorT();
    cond_sensor();
    printLCD();
     delay(1000);//take a reading every second
   // saveSD();
     
  }  */
  if (count == 2){
    readPot();

     delay(1000);//take a reading every second
   // saveSD();
    
  }
  else if (count == 0){
    standby();
  }
}
  
void readPot(){
  digitalWrite(valve, LOW);
  digitalWrite(led, LOW);
  valpot = analogRead(pot);
  mvalpot = map(valpot,0, 1023, 0, 100);
  Serial.print("Calibración de riego: ");
  Serial.print(mvalpot);
  lcd.clear();
  lcd.home();
  lcd.print("Riego abajo de: ");
  lcd.setCursor(0,1);
  lcd.print(mvalpot);
}
void readSensor()
{
   //digitalWrite(soilPower, HIGH);//turn D7 "On"
    delay(10);//wait 10 milliseconds 
    val = analogRead(soilPin);//Read the SIG value form sensor 
    //digitalWrite(soilPower, LOW);//turn D7 "Off"
    val_2 = analogRead(soilPin_2);//Read the SIG value form sensor 
    //digitalWrite(soilPower, LOW);//turn D7 "Off"
    mval = map(val,0,1023,0,100);
    mval_2 = map(val_2,0,1023,0,100);
    Serial.print("Humedad 1 = "); 
    Serial.println(mval);
    Serial.print("Humedad 2 = "); 
    Serial.println(mval_2);
    //This 1 second timefrme is used so you can test the sensor and see it change in real-time. 
    //For in-plant applications, you will want to take readings much less frequently.
   
}

void sensorT(){
  sensors.requestTemperatures(); // Send the command to get temperatures
  T1=sensors.getTempCByIndex(0); // Sensor 0
  T2=sensors.getTempCByIndex(1); // Sensor 1
  Serial.print(T1);
  Serial.print(", ");
  Serial.println(T2);
}


void cond_sensor(){
  if (mval <mvalpot || mval_2 < mvalpot){
    digitalWrite(valve, HIGH);
    digitalWrite(led, HIGH);
  }
    else{
    digitalWrite(valve, LOW);
    digitalWrite(led, LOW);
    }
}
/*
void printLCD()
{
 lcd.clear();
  lcd.home();
  lcd.print("H1: ");
  lcd.print(mval);
  lcd.print(" H2: ");
  lcd.print(mval_2);
  lcd.setCursor(0,1);
  lcd.print("T1: ");
  lcd.print((int)T1);
  lcd.print(" T2: ");
  lcd.print((int)T2);
}

void saveSD()
{
  
}

void standby(){
  //logFile.println("En espera");
  //logFile.close();
  lcd.clear();
  lcd.home();
  lcd.print("En espera");
  Serial.println("En espera");
  digitalWrite(valve, LOW);
}

void but_state()
{
  if (state == HIGH && flag == 0) {
    flag++;
  }
  if (state == LOW && flag == 1){
    count++;
    flag--;
      if (count > 2){
    count = 0;
      }*/
  }
  }
